
from odoo import api, fields, models
from odoo.addons.saas_worker import metabase
from odoo.addons.saas_worker.util import version_gte


if version_gte("saas~16.4"):

    class Onboarding(models.Model):
        _inherit = 'onboarding.onboarding'

        def _search_or_create_progress(self):
            current_progress_id = super()._search_or_create_progress()
            if (current_progress_id.onboarding_id.route_name == "website_sale_dashboard"
                and not current_progress_id.is_onboarding_closed):
                # As we have no callback from accounts. to the customer instance
                # once the custom domain is set-up, we automatically check and
                # validate the step when loading the dashboard progress.
                custom_domains = metabase.get_hostnames(self.env.cr.dbname)
                if custom_domains:
                    self.env["onboarding.onboarding.step"].action_validate_step(
                        "saas_website_onboarding.onboarding_onboarding_step_custom_domain",
                    )
            return current_progress_id

    class OnboardingStep(models.Model):
        _inherit = 'onboarding.onboarding.step'

        @api.model
        def action_open_account_onboarding_domain_name(self):
            """ Onboarding step for custom domain name. """
            return {
                'type': 'ir.actions.act_url',
                'url':  '/saas_trial/my_dns',
                'target': 'new',
            }
